## jansson 2.6

=== CMakeLists.txt ===
# Notes:
#
# Author: Paul Harris, June 2012
# Additions: Joakim Soderberg, Febuary 2013
#
# Supports: building static/shared, release/debug/etc, can also build html docs
# and some of the tests.
# Note that its designed for out-of-tree builds, so it will not pollute your
# source tree.
#
# TODO 1: Finish implementing tests. api tests are working, but the valgrind
# variants are not flagging problems.
#
# TODO 2: There is a check_exports script that would try and incorporate.
#
# TODO 3: Consolidate version numbers, currently the version number is written
# into: * cmake (here) * autotools (the configure) * source code header files.
# Should not be written directly into header files, autotools/cmake can do
# that job.
#
# Brief intro on how to use cmake:
# > mkdir build (somewhere - we do out-of-tree builds)
# > use cmake, ccmake, or cmake-gui to configure the project. for linux, you
# can only choose one variant: release,debug,etc... and static or shared.
# >> example:
# >> cd build
# >> ccmake -i ../path_to_jansson_dir
# >>  inside, configure your options. press C until there are no lines
#     with * next to them.
# >>  note, I like to configure the 'install' path to ../install, so I get
#     self-contained clean installs I can point other projects to.
# >>  press G to 'generate' the project files.
# >> make (to build the project)
# >> make install
# >> make test (to run the tests, if you enabled them)
#
# Brief description on how it works:
# There is a small heirachy of CMakeLists.txt files which define how the
# project is built.
# Header file detection etc is done, and the results are written into config.h
# and jansson_config.h, which are generated from the corresponding
# config.h.cmake and jansson_config.h.cmake template files.
# The generated header files end up in the build directory - not in
# the source directory.
# The rest is down to the usual make process.



cmake_minimum_required (VERSION 2.8)
# required for exports? cmake_minimum_required (VERSION 2.8.6)
project (jansson C)

# Options
OPTION (BUILD_SHARED_LIBS "Build shared libraries." OFF)
OPTION (USE_URANDOM "Use /dev/urandom to seed the hash function." ON)
OPTION (USE_WINDOWS_CRYPTOAPI "Use CryptGenRandom to seed the hash function." ON)

if (MSVC)
   # This option must match the settings used in your program, in particular if you
	# are linking statically
	OPTION( STATIC_CRT "Link the static CRT libraries" OFF )
endif ()

# Set some nicer output dirs.
SET(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/bin)
SET(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/lib)
SET(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/lib)

# Give the debug version a different postfix for windows,
# so both the debug and release version can be built in the
# same build-tree on Windows (MSVC).
if (WIN32)
   SET (CMAKE_DEBUG_POSTFIX "_d")
else (WIN32)
endif (WIN32)

# This is how I thought it should go
# set (JANSSON_VERSION "2.3.1")
# set (JANSSON_SOVERSION 2)

set(JANSSON_DISPLAY_VERSION "2.6")

# This is what is required to match the same numbers as automake's
set (JANSSON_VERSION "4.6.0")
set (JANSSON_SOVERSION 4)

# for CheckFunctionKeywords
set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

INCLUDE (CheckCSourceCompiles)
include (CheckFunctionExists)
include (CheckFunctionKeywords)
include (CheckIncludeFiles)
include (CheckTypeSize)

if (MSVC)
   # Turn off Microsofts "security" warnings.
   add_definitions( "/W3 /D_CRT_SECURE_NO_WARNINGS /wd4005 /wd4996 /nologo" )
   
   if (STATIC_CRT)
      set(CMAKE_C_FLAGS_RELEASE "/MT")
      set(CMAKE_C_FLAGS_DEBUG "/MTd")
   endif()
   
endif()

if (CMAKE_COMPILER_IS_GNUCC OR CMAKE_COMPILER_IS_GNUCXX)
   set(CMAKE_C_FLAGS "-fPIC")
endif()

check_include_files (endian.h HAVE_ENDIAN_H)
check_include_files (fcntl.h HAVE_FCNTL_H)
check_include_files (sched.h HAVE_SCHED_H)
check_include_files (unistd.h HAVE_UNISTD_H)
check_include_files (sys/param.h HAVE_SYS_PARAM_H)
check_include_files (sys/stat.h HAVE_SYS_STAT_H)
check_include_files (sys/time.h HAVE_SYS_TIME_H)
check_include_files (sys/time.h HAVE_SYS_TYPES_H)

check_function_exists (close HAVE_CLOSE)
check_function_exists (getpid HAVE_GETPID)
check_function_exists (gettimeofday HAVE_GETTIMEOFDAY)
check_function_exists (open HAVE_OPEN)
check_function_exists (read HAVE_READ)
check_function_exists (sched_yield HAVE_SCHED_YIELD)

# Check for the int-type includes
check_include_files (stdint.h HAVE_STDINT_H)

# Check our 64 bit integer sizes
check_type_size (__int64 __INT64)
check_type_size (int64_t INT64_T)
check_type_size ("long long" LONG_LONG_INT)

# Check our 32 bit integer sizes
check_type_size (int32_t INT32_T)
check_type_size (__int32 __INT32)
check_type_size ("long" LONG_INT)
check_type_size ("int" INT)
if (HAVE_INT32_T)
   set (JSON_INT32 int32_t)
elseif (HAVE___INT32)
   set (JSON_INT32 __int32)
elseif (HAVE_LONG_INT AND (${LONG_INT} EQUAL 4))
   set (JSON_INT32 long)
elseif (HAVE_INT AND (${INT} EQUAL 4))
   set (JSON_INT32 int)
else ()
   message (FATAL_ERROR "Could not detect a valid 32-bit integer type")
endif ()

check_type_size (uint32_t UINT32_T)
check_type_size (__uint32 __UINT32)
check_type_size ("unsigned long" UNSIGNED_LONG_INT)
check_type_size ("unsigned int" UNSIGNED_INT)
if (HAVE_UINT32_T)
   set (JSON_UINT32 uint32_t)
elseif (HAVE___UINT32)
   set (JSON_UINT32 __uint32)
elseif (HAVE_UNSIGNED_LONG_INT AND (${UNSIGNED_LONG_INT} EQUAL 4))
   set (JSON_UINT32 "unsigned long")
elseif (HAVE_UNSIGNED_INT AND (${UNSIGNED_INT} EQUAL 4))
   set (JSON_UINT32 "unsigned int")
else ()
   message (FATAL_ERROR "Could not detect a valid unsigned 32-bit integer type")
endif ()

# Check for ssize_t and SSIZE_T existance.
check_type_size(ssize_t SSIZE_T)
check_type_size(SSIZE_T UPPERCASE_SSIZE_T)
if(NOT HAVE_SSIZE_T)
   if(HAVE_UPPERCASE_SSIZE_T)
      set(JSON_SSIZE SSIZE_T)
   else()
      set(JSON_SSIZE int)
   endif()
endif()
set(CMAKE_EXTRA_INCLUDE_FILES "")

# Check for all the variants of strtoll
check_function_exists (strtoll HAVE_STRTOLL)
check_function_exists (strtoq HAVE_STRTOQ)
check_function_exists (_strtoi64 HAVE__STRTOI64)

# Figure out what variant we should use
if (HAVE_STRTOLL)
   set (JSON_STRTOINT strtoll)
elseif (HAVE_STRTOQ)
   set (JSON_STRTOINT strtoq)
elseif (HAVE__STRTOI64)
   set (JSON_STRTOINT _strtoi64)
else ()
   # fallback to strtol (32 bit)
   # this will set all the required variables
   set (JSON_STRTOINT strtol)
   set (JSON_INT_T long)
   set (JSON_INTEGER_FORMAT "\"ld\"")
endif ()

# if we haven't defined JSON_INT_T, then we have a 64 bit conversion function.
# detect what to use for the 64 bit type.
# Note: I will prefer long long if I can get it, as that is what the automake system aimed for.
if (NOT DEFINED JSON_INT_T)
   if (HAVE_LONG_LONG_INT AND (${LONG_LONG_INT} EQUAL 8))
      set (JSON_INT_T "long long")
   elseif (HAVE_INT64_T)
      set (JSON_INT_T int64_t)
   elseif (HAVE___INT64)
      set (JSON_INT_T __int64)
   else ()
      message (FATAL_ERROR "Could not detect 64 bit type, although I detected the strtoll equivalent")
   endif ()

   # Apparently, Borland BCC and MSVC wants I64d,
   # Borland BCC could also accept LD
   # and gcc wants ldd,
   # I am not sure what cygwin will want, so I will assume I64d

   if (WIN32) # matches both msvc and cygwin
      set (JSON_INTEGER_FORMAT "\"I64d\"")
   else ()
      set (JSON_INTEGER_FORMAT "\"lld\"")
   endif ()
endif ()


# If locale.h and localeconv() are available, define to 1, otherwise to 0.
check_include_files (locale.h HAVE_LOCALE_H)
check_function_exists (localeconv HAVE_LOCALECONV)

if (HAVE_LOCALECONV AND HAVE_LOCALE_H)
   set (JSON_HAVE_LOCALECONV 1)
else ()
   set (JSON_HAVE_LOCALECONV 0)
endif ()

# check if we have setlocale
check_function_exists (setlocale HAVE_SETLOCALE)

# Check what the inline keyword is.
# Note that the original JSON_INLINE was always set to just 'inline', so this goes further.
check_function_keywords("inline")
check_function_keywords("__inline")
check_function_keywords("__inline__")

if (HAVE_INLINE)
   set (JSON_INLINE inline)
elseif (HAVE___INLINE)
   set (JSON_INLINE __inline)
elseif (HAVE___INLINE__)
   set (JSON_INLINE __inline__)
else (HAVE_INLINE)
   # no inline on this platform
   set (JSON_INLINE)
endif (HAVE_INLINE)

# Find our snprintf
check_function_exists (snprintf HAVE_SNPRINTF)
check_function_exists (_snprintf HAVE__SNPRINTF)

if (HAVE_SNPRINTF)
   set (JSON_SNPRINTF snprintf)
elseif (HAVE__SNPRINTF)
   set (JSON_SNPRINTF _snprintf)
endif ()

check_c_source_compiles ("int main() { unsigned long val; __sync_bool_compare_and_swap(&val, 0, 1); return 0; } " HAVE_SYNC_BUILTINS)
check_c_source_compiles ("int main() { char l; unsigned long v; __atomic_test_and_set(&l, __ATOMIC_RELAXED); __atomic_store_n(&v, 1, __ATOMIC_ACQ_REL); __atomic_load_n(&v, __ATOMIC_ACQUIRE); return 0; }" HAVE_ATOMIC_BUILTINS)

# Create pkg-conf file.
# (We use the same files as ./configure does, so we
#  have to defined the same variables used there).
if(NOT DEFINED CMAKE_INSTALL_LIBDIR)
  set(CMAKE_INSTALL_LIBDIR lib)
endif(NOT DEFINED CMAKE_INSTALL_LIBDIR)
set(prefix      ${CMAKE_INSTALL_PREFIX})
set(exec_prefix ${CMAKE_INSTALL_PREFIX})
set(libdir      ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR})
set(VERSION     ${JANSSON_DISPLAY_VERSION})
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/jansson.pc.in
               ${CMAKE_CURRENT_BINARY_DIR}/jansson.pc @ONLY)

# configure the public config file
configure_file (${CMAKE_CURRENT_SOURCE_DIR}/cmake/jansson_config.h.cmake
                ${CMAKE_CURRENT_BINARY_DIR}/include/jansson_config.h)

# Copy the jansson.h file to the public include folder
file (COPY ${CMAKE_CURRENT_SOURCE_DIR}/src/jansson.h
           DESTINATION ${CMAKE_CURRENT_BINARY_DIR}/include/)


# configure the private config file
configure_file (${CMAKE_CURRENT_SOURCE_DIR}/cmake/config.h.cmake
                ${CMAKE_CURRENT_BINARY_DIR}/private_include/config.h)

# and tell the source code to include it
add_definitions (-DHAVE_CONFIG_H)

include_directories (${CMAKE_CURRENT_BINARY_DIR}/include)
include_directories (${CMAKE_CURRENT_BINARY_DIR}/private_include)

# Add the lib sources.
file (GLOB C_FILES src/*.c)

if (BUILD_SHARED_LIBS)

   add_library (jansson SHARED ${C_FILES} src/jansson.def)

   set_target_properties (jansson PROPERTIES
      VERSION ${JANSSON_VERSION}
      SOVERSION ${JANSSON_SOVERSION})

else ()

   add_library (jansson ${C_FILES})

endif ()

# LIBRARY for linux
# RUNTIME for windows (when building shared)
install (TARGETS jansson
   ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
   LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
   RUNTIME DESTINATION bin
)

install (FILES
         ${CMAKE_CURRENT_BINARY_DIR}/include/jansson_config.h
         ${CMAKE_CURRENT_SOURCE_DIR}/src/jansson.h
         DESTINATION include)

install (FILES 
         ${CMAKE_CURRENT_BINARY_DIR}/jansson.pc
         DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

# For building Documentation (uses Sphinx)
OPTION (BUILD_DOCS "Build documentation (uses python-sphinx)." ON)
if (BUILD_DOCS)
   find_package(Sphinx)

   if (NOT SPHINX_FOUND)
      message(WARNING "Sphinx not found. Cannot generate documentation! 
      Set -DBUILD_DOCS=0 to get rid of this message.")
   else()
      if (Sphinx_VERSION_STRING VERSION_LESS 1.0)
         message(WARNING "Your Sphinx version is too old! 
               This project requires Sphinx v1.0 or above to produce 
               proper documentation (you have v${Sphinx_VERSION_STRING}).
               You will get output but it will have errors.")
      endif()

      # configured documentation tools and intermediate build results
      set(BINARY_BUILD_DIR "${CMAKE_CURRENT_BINARY_DIR}/_build")

      # Sphinx cache with pickled ReST documents
      set(SPHINX_CACHE_DIR "${CMAKE_CURRENT_BINARY_DIR}/_doctrees")

      # CMake could be used to build the conf.py file too,
      # eg it could automatically write the version of the program or change the theme.

## jansson 2.1

=== debian/changelog ===
jansson (2.1-1) unstable; urgency=low

  * New upstream release
    - Fix set-but-not-used warning/error in a test (Closes: #625359)
  * Update libjansson4 *.symbols file
  * Bump Standards-Version to 3.9.2 (no changes needed)

 -- Alessandro Ghedini <al3xbio@gmail.com>  Sat, 11 Jun 2011 00:01:40 +0200

jansson (2.0.1-1) unstable; urgency=low

  * Initial release (Closes: #561051)

 -- Alessandro Ghedini <al3xbio@gmail.com>  Thu, 31 Mar 2011 22:21:16 +0200

=== debian/control ===
Source: jansson
Priority: optional
Maintainer: Alessandro Ghedini <al3xbio@gmail.com>
Build-Depends: debhelper (>= 7.0.50~), dh-autoreconf, python-sphinx (>= 1.0)
Standards-Version: 3.9.2
Section: libs
Homepage: http://www.digip.org/jansson/
Vcs-Git: git://git.debian.org/collab-maint/jansson.git
Vcs-Browser: http://git.debian.org/?p=collab-maint/jansson.git;a=summary

Package: libjansson-dev
Section: libdevel
Architecture: any
Depends: libjansson4 (= ${binary:Version}), ${misc:Depends}
Description: C library for encoding, decoding and manipulating JSON data (dev)
 Jansson is a C library for encoding, decoding and manipulating JSON data.
 .
 It features:
  * Simple and intuitive API and data model
  * Comprehensive documentation
  * No dependencies on other libraries
  * Full Unicode support (UTF-8)
  * Extensive test suite
 .
 This package contains the development files for jansson.


Package: libjansson4
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: C library for encoding, decoding and manipulating JSON data
 Jansson is a C library for encoding, decoding and manipulating JSON data.
 .
 It features:
  * Simple and intuitive API and data model
  * Comprehensive documentation
  * No dependencies on other libraries
  * Full Unicode support (UTF-8)
  * Extensive test suite

Package: libjansson-doc
Section: doc
Architecture: any
Depends: libjansson4 (= ${binary:Version}), ${misc:Depends}, libjs-jquery
Description: C library for encoding, decoding and manipulating JSON data (doc)
 Jansson is a C library for encoding, decoding and manipulating JSON data.
 .
 It features:
  * Simple and intuitive API and data model
  * Comprehensive documentation
  * No dependencies on other libraries
  * Full Unicode support (UTF-8)
  * Extensive test suite
 .
 This package contains the documentation for jansson.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1

%:
	dh $@ --with autoreconf

override_dh_auto_build:
	dh_auto_build
	$(MAKE) html

override_dh_install:
	dh_install -Xjquery.js

=== debian/watch ===
version=3

http://githubredir.debian.net/github/akheron/jansson .*/v(.*).tar.gz

## jansson 2.2.1

=== debian/changelog ===
jansson (2.2.1-1) unstable; urgency=low

  * New upstream release

 -- Alessandro Ghedini <al3xbio@gmail.com>  Thu, 06 Oct 2011 21:07:15 +0200

jansson (2.2-1) unstable; urgency=low

  * New upstream release
  * Do not use upstream tarball from GitHub anymore, 
    update watch file accordingly
  * Replace dh-autoreconf with autotools-dev
  * Bump debhelper compat level to 8
  * Update *.symbols file
  * Make -doc package Architecture: all
  * Do not bundle underscore.js library included by sphinx
  * Don't depend on libjansson4 from -doc package 
    (fixes not-binnmuable-all-depends-any lintian error)
  * Move libjansson4 package up in debian/control
  * Remove dh_install override from debian/rules (not needed)

 -- Alessandro Ghedini <al3xbio@gmail.com>  Sat, 03 Sep 2011 14:29:48 +0200

=== debian/control ===
Source: jansson
Priority: optional
Maintainer: Alessandro Ghedini <al3xbio@gmail.com>
Build-Depends: debhelper (>= 8), autotools-dev, python-sphinx (>= 1.0)
Standards-Version: 3.9.2
Section: libs
Homepage: http://www.digip.org/jansson/
Vcs-Git: git://git.debian.org/collab-maint/jansson.git
Vcs-Browser: http://git.debian.org/?p=collab-maint/jansson.git;a=summary

Package: libjansson4
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: C library for encoding, decoding and manipulating JSON data
 Jansson is a C library for encoding, decoding and manipulating JSON data.
 .
 It features:
  * Simple and intuitive API and data model
  * Comprehensive documentation
  * No dependencies on other libraries
  * Full Unicode support (UTF-8)
  * Extensive test suite

Package: libjansson-dev
Section: libdevel
Architecture: any
Depends: libjansson4 (= ${binary:Version}), ${misc:Depends}
Description: C library for encoding, decoding and manipulating JSON data (dev)
 Jansson is a C library for encoding, decoding and manipulating JSON data.
 .
 It features:
  * Simple and intuitive API and data model
  * Comprehensive documentation
  * No dependencies on other libraries
  * Full Unicode support (UTF-8)
  * Extensive test suite
 .
 This package contains the development files for jansson.

Package: libjansson-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}, libjs-jquery, libjs-underscore
Description: C library for encoding, decoding and manipulating JSON data (doc)
 Jansson is a C library for encoding, decoding and manipulating JSON data.
 .
 It features:
  * Simple and intuitive API and data model
  * Comprehensive documentation
  * No dependencies on other libraries
  * Full Unicode support (UTF-8)
  * Extensive test suite
 .
 This package contains the documentation for jansson.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1

%:
	dh $@ --with autotools-dev

override_dh_auto_build:
	dh_auto_build
	$(MAKE) html

=== debian/watch ===
version=3

http://www.digip.org/jansson/releases/jansson-([\d+\.]*).tar.gz

## jansson 2.3

=== debian/changelog ===
jansson (2.3-2) unstable; urgency=low

  * Do not use dh_sphinxdoc anymore (should fix the various FTBFS)

 -- Alessandro Ghedini <al3xbio@gmail.com>  Mon, 13 Feb 2012 10:21:19 +0100

jansson (2.3-1) unstable; urgency=low

  * New upstream release
  * Use dh_sphinxdoc script
    - Build depends on python-sphinx (>= 1.0.7+dfsg)
    - Link to and depend on libjs-backbone in -doc package
  * Add libjansson-dbg debug package
  * Update *.symbols file

 -- Alessandro Ghedini <al3xbio@gmail.com>  Fri, 27 Jan 2012 21:54:54 +0100

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,9 @@
 Source: jansson
 Priority: optional
 Maintainer: Alessandro Ghedini <al3xbio@gmail.com>
-Build-Depends: debhelper (>= 8), autotools-dev, python-sphinx (>= 1.0)
+Build-Depends: debhelper (>= 8),
+ autotools-dev,
+ python-sphinx (>= 1.0)
 Standards-Version: 3.9.2
 Section: libs
 Homepage: http://www.digip.org/jansson/
@@ -40,7 +42,11 @@
 Package: libjansson-doc
 Section: doc
 Architecture: all
-Depends: ${misc:Depends}, libjs-jquery, libjs-underscore
+Depends: ${misc:Depends},
+ libjs-backbone,
+ libjs-jquery,
+ libjs-underscore,
+ libjs-sphinxdoc (>= 1.0)
 Description: C library for encoding, decoding and manipulating JSON data (doc)
  Jansson is a C library for encoding, decoding and manipulating JSON data.
  .
@@ -52,3 +58,20 @@
   * Extensive test suite
  .
  This package contains the documentation for jansson.
+
+Package: libjansson-dbg
+Priority: extra
+Section: debug
+Architecture: any
+Depends: ${misc:Depends}, libjansson4 (= ${binary:Version})
+Description: C library for encoding, decoding and manipulating JSON data (debug)
+ Jansson is a C library for encoding, decoding and manipulating JSON data.
+ .
+ It features:
+  * Simple and intuitive API and data model
+  * Comprehensive documentation
+  * No dependencies on other libraries
+  * Full Unicode support (UTF-8)
+  * Extensive test suite
+ .
+ This package provides the debugging symbols for jansson.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1

%:
	dh $@ --with=autotools-dev

override_dh_auto_build:
	dh_auto_build
	$(MAKE) html

override_dh_strip:
	dh_strip --dbg-package=libjansson-dbg

## jansson 2.3.1

=== debian/changelog ===
jansson (2.3.1-2) unstable; urgency=low

  * Make -dev package Multi-Arch: same too
  * Move python-sphinx to build-depends-indep

 -- Alessandro Ghedini <ghedo@debian.org>  Sun, 03 Jun 2012 17:05:29 +0200

jansson (2.3.1-1) unstable; urgency=low

  * New upstream release
  * Update debian/copyright format as in Debian Policy 3.9.3
  * Bump Standards-Version to 3.9.3
  * Bump debhelper compat level to 9
  * Email change: Alessandro Ghedini -> ghedo@debian.org
  * Add Multi-Arch headers
  * Use multi-arch aware paths in *.install files
  * Update upstream copyright years

 -- Alessandro Ghedini <ghedo@debian.org>  Sat, 21 Apr 2012 14:30:56 +0200

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,11 @@
 Source: jansson
 Priority: optional
-Maintainer: Alessandro Ghedini <al3xbio@gmail.com>
-Build-Depends: debhelper (>= 8),
- autotools-dev,
+Maintainer: Alessandro Ghedini <ghedo@debian.org>
+Build-Depends: debhelper (>= 9),
+ autotools-dev
+Build-Depends-Indep:
  python-sphinx (>= 1.0)
-Standards-Version: 3.9.2
+Standards-Version: 3.9.3
 Section: libs
 Homepage: http://www.digip.org/jansson/
 Vcs-Git: git://git.debian.org/collab-maint/jansson.git
@@ -13,6 +14,8 @@
 Package: libjansson4
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
+Pre-Depends: ${misc:Pre-Depends}
+Multi-Arch: same
 Description: C library for encoding, decoding and manipulating JSON data
  Jansson is a C library for encoding, decoding and manipulating JSON data.
  .
@@ -27,6 +30,7 @@
 Section: libdevel
 Architecture: any
 Depends: libjansson4 (= ${binary:Version}), ${misc:Depends}
+Multi-Arch: same
 Description: C library for encoding, decoding and manipulating JSON data (dev)
  Jansson is a C library for encoding, decoding and manipulating JSON data.
  .
@@ -64,6 +68,7 @@
 Section: debug
 Architecture: any
 Depends: ${misc:Depends}, libjansson4 (= ${binary:Version})
+Multi-Arch: same
 Description: C library for encoding, decoding and manipulating JSON data (debug)
  Jansson is a C library for encoding, decoding and manipulating JSON data.
  .

=== debian/rules ===
--- 
+++ 
@@ -6,7 +6,9 @@
 
 override_dh_auto_build:
 	dh_auto_build
+ifeq ($(shell dpkg-query -s python-sphinx 1>/dev/null 2>&1 && echo yes),yes)
 	$(MAKE) html
+endif
 
 override_dh_strip:
 	dh_strip --dbg-package=libjansson-dbg

## jansson 2.4

=== debian/changelog ===
jansson (2.4-1) unstable; urgency=low

  * New upstream release
    - Fix FTBFS on ppc64. Thanks to Aurelien Jarno (Closes: #684468)
  * Update *.symbols file

 -- Alessandro Ghedini <ghedo@debian.org>  Sun, 23 Sep 2012 14:00:33 +0200

## jansson 2.5

=== debian/changelog ===
jansson (2.5-2) unstable; urgency=medium

  * Fix vcs-field-not-canonical
  * Bump Standards-Version to 3.9.5 (no changes needed)
  * Use dh-autoreconf instead of autotools-dev to fix FTBFS on ppc64el.
    Thanks to Logan Rosen for the patch (Closes: #732822)

 -- Alessandro Ghedini <ghedo@debian.org>  Sun, 22 Dec 2013 15:31:36 +0100

jansson (2.5-1) unstable; urgency=low

  * New upstream release
  * Bump Standards-Version to 3.9.4
  * Update upstream copyright years

 -- Alessandro Ghedini <ghedo@debian.org>  Fri, 20 Sep 2013 10:44:52 +0200

=== debian/control ===
--- 
+++ 
@@ -1,15 +1,13 @@
 Source: jansson
 Priority: optional
 Maintainer: Alessandro Ghedini <ghedo@debian.org>
-Build-Depends: debhelper (>= 9),
- autotools-dev
-Build-Depends-Indep:
- python-sphinx (>= 1.0)
-Standards-Version: 3.9.3
+Build-Depends: debhelper (>= 9), dh-autoreconf
+Build-Depends-Indep: python-sphinx (>= 1.0)
+Standards-Version: 3.9.5
 Section: libs
+Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/jansson.git
+Vcs-Git: git://anonscm.debian.org/collab-maint/jansson.git
 Homepage: http://www.digip.org/jansson/
-Vcs-Git: git://git.debian.org/collab-maint/jansson.git
-Vcs-Browser: http://git.debian.org/?p=collab-maint/jansson.git;a=summary
 
 Package: libjansson4
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -2,7 +2,7 @@
 #export DH_VERBOSE=1
 
 %:
-	dh $@ --with=autotools-dev
+	dh $@ --with=autoreconf
 
 override_dh_auto_build:
 	dh_auto_build

## jansson 2.6

=== debian/changelog ===
jansson (2.6-1) unstable; urgency=high

  * New upstream release
    - Fix hash function so that it is not susceptible to predictable hash
      collisions as per CVE-2013-6401 (Closes: #738647)
    - Set urgency=high accordingly
  * Update symbols file

 -- Alessandro Ghedini <ghedo@debian.org>  Wed, 12 Feb 2014 14:27:38 +0100

## jansson 2.7

=== CMakeLists.txt ===
--- 
+++ 
@@ -51,26 +51,26 @@
 project (jansson C)
 
 # Options
-OPTION (BUILD_SHARED_LIBS "Build shared libraries." OFF)
-OPTION (USE_URANDOM "Use /dev/urandom to seed the hash function." ON)
-OPTION (USE_WINDOWS_CRYPTOAPI "Use CryptGenRandom to seed the hash function." ON)
+option(JANSSON_BUILD_SHARED_LIBS "Build shared libraries." OFF)
+option(USE_URANDOM "Use /dev/urandom to seed the hash function." ON)
+option(USE_WINDOWS_CRYPTOAPI "Use CryptGenRandom to seed the hash function." ON)
 
 if (MSVC)
    # This option must match the settings used in your program, in particular if you
 	# are linking statically
-	OPTION( STATIC_CRT "Link the static CRT libraries" OFF )
+	option(JANSSON_STATIC_CRT "Link the static CRT libraries" OFF )
 endif ()
 
 # Set some nicer output dirs.
-SET(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/bin)
-SET(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/lib)
-SET(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/lib)
+set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/bin)
+set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/lib)
+set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/lib)
 
 # Give the debug version a different postfix for windows,
 # so both the debug and release version can be built in the
 # same build-tree on Windows (MSVC).
 if (WIN32)
-   SET (CMAKE_DEBUG_POSTFIX "_d")
+   set(CMAKE_DEBUG_POSTFIX "_d")
 else (WIN32)
 endif (WIN32)
 
@@ -78,16 +78,16 @@
 # set (JANSSON_VERSION "2.3.1")
 # set (JANSSON_SOVERSION 2)
 
-set(JANSSON_DISPLAY_VERSION "2.6")
+set(JANSSON_DISPLAY_VERSION "2.7")
 
 # This is what is required to match the same numbers as automake's
-set (JANSSON_VERSION "4.6.0")
-set (JANSSON_SOVERSION 4)
+set(JANSSON_VERSION "4.7.0")
+set(JANSSON_SOVERSION 4)
 
 # for CheckFunctionKeywords
 set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
 
-INCLUDE (CheckCSourceCompiles)
+include (CheckCSourceCompiles)
 include (CheckFunctionExists)
 include (CheckFunctionKeywords)
 include (CheckIncludeFiles)
@@ -104,8 +104,8 @@
    
 endif()
 
-if (CMAKE_COMPILER_IS_GNUCC OR CMAKE_COMPILER_IS_GNUCXX)
-   set(CMAKE_C_FLAGS "-fPIC")
+if (NOT WIN32 AND (CMAKE_COMPILER_IS_GNUCC OR CMAKE_COMPILER_IS_GNUCXX))
+   add_definitions("-fPIC")
 endif()
 
 check_include_files (endian.h HAVE_ENDIAN_H)
@@ -149,10 +149,12 @@
    message (FATAL_ERROR "Could not detect a valid 32-bit integer type")
 endif ()
 
+check_type_size ("unsigned long" UNSIGNED_LONG_INT)
+check_type_size ("unsigned int" UNSIGNED_INT)
+check_type_size ("unsigned short" UNSIGNED_SHORT)
+
 check_type_size (uint32_t UINT32_T)
 check_type_size (__uint32 __UINT32)
-check_type_size ("unsigned long" UNSIGNED_LONG_INT)
-check_type_size ("unsigned int" UNSIGNED_INT)
 if (HAVE_UINT32_T)
    set (JSON_UINT32 uint32_t)
 elseif (HAVE___UINT32)
@@ -163,6 +165,30 @@
    set (JSON_UINT32 "unsigned int")
 else ()
    message (FATAL_ERROR "Could not detect a valid unsigned 32-bit integer type")
+endif ()
+
+check_type_size (uint16_t UINT16_T)
+check_type_size (__uint16 __UINT16)
+if (HAVE_UINT16_T)
+   set (JSON_UINT16 uint16_t)
+elseif (HAVE___UINT16)
+   set (JSON_UINT16 __uint16)
+elseif (HAVE_UNSIGNED_INT AND (${UNSIGNED_INT} EQUAL 2))
+   set (JSON_UINT16 "unsigned int")
+elseif (HAVE_UNSIGNED_SHORT AND (${UNSIGNED_SHORT} EQUAL 2))
+   set (JSON_UINT16 "unsigned short")
+else ()
+   message (FATAL_ERROR "Could not detect a valid unsigned 16-bit integer type")
+endif ()
+
+check_type_size (uint8_t UINT8_T)
+check_type_size (__uint8 __UINT8)
+if (HAVE_UINT8_T)
+   set (JSON_UINT8 uint8_t)
+elseif (HAVE___UINT8)
+   set (JSON_UINT8 __uint8)
+else ()
+   set (JSON_UINT8 "unsigned char")
 endif ()
 
 # Check for ssize_t and SSIZE_T existance.
@@ -232,10 +258,10 @@
    set (JSON_HAVE_LOCALECONV 1)
 else ()
    set (JSON_HAVE_LOCALECONV 0)
-endif ()
+endif()
 
 # check if we have setlocale
-check_function_exists (setlocale HAVE_SETLOCALE)
+check_function_exists(setlocale HAVE_SETLOCALE)
 
 # Check what the inline keyword is.
 # Note that the original JSON_INLINE was always set to just 'inline', so this goes further.
@@ -244,28 +270,28 @@
 check_function_keywords("__inline__")
 
 if (HAVE_INLINE)
-   set (JSON_INLINE inline)
+   set(JSON_INLINE inline)
 elseif (HAVE___INLINE)
-   set (JSON_INLINE __inline)
+   set(JSON_INLINE __inline)
 elseif (HAVE___INLINE__)
-   set (JSON_INLINE __inline__)
-else (HAVE_INLINE)
+   set(JSON_INLINE __inline__)
+else()
    # no inline on this platform
    set (JSON_INLINE)
-endif (HAVE_INLINE)
+endif()
 
 # Find our snprintf
 check_function_exists (snprintf HAVE_SNPRINTF)
 check_function_exists (_snprintf HAVE__SNPRINTF)
 
 if (HAVE_SNPRINTF)
-   set (JSON_SNPRINTF snprintf)
+   set(JSON_SNPRINTF snprintf)
 elseif (HAVE__SNPRINTF)
-   set (JSON_SNPRINTF _snprintf)
-endif ()
+   set(JSON_SNPRINTF _snprintf)
+endif () 
 
 check_c_source_compiles ("int main() { unsigned long val; __sync_bool_compare_and_swap(&val, 0, 1); return 0; } " HAVE_SYNC_BUILTINS)
-check_c_source_compiles ("int main() { char l; unsigned long v; __atomic_test_and_set(&l, __ATOMIC_RELAXED); __atomic_store_n(&v, 1, __ATOMIC_ACQ_REL); __atomic_load_n(&v, __ATOMIC_ACQUIRE); return 0; }" HAVE_ATOMIC_BUILTINS)
+check_c_source_compiles ("int main() { char l; unsigned long v; __atomic_test_and_set(&l, __ATOMIC_RELAXED); __atomic_store_n(&v, 1, __ATOMIC_RELEASE); __atomic_load_n(&v, __ATOMIC_ACQUIRE); return 0; }" HAVE_ATOMIC_BUILTINS)
 
 # Create pkg-conf file.
 # (We use the same files as ./configure does, so we
@@ -288,72 +314,48 @@
 file (COPY ${CMAKE_CURRENT_SOURCE_DIR}/src/jansson.h
            DESTINATION ${CMAKE_CURRENT_BINARY_DIR}/include/)
 
+add_definitions(-DJANSSON_USING_CMAKE)
 
 # configure the private config file
-configure_file (${CMAKE_CURRENT_SOURCE_DIR}/cmake/config.h.cmake
-                ${CMAKE_CURRENT_BINARY_DIR}/private_include/config.h)
+configure_file (${CMAKE_CURRENT_SOURCE_DIR}/cmake/jansson_private_config.h.cmake
+                ${CMAKE_CURRENT_BINARY_DIR}/private_include/jansson_private_config.h)
 
 # and tell the source code to include it
-add_definitions (-DHAVE_CONFIG_H)
+add_definitions(-DHAVE_CONFIG_H)
 
 include_directories (${CMAKE_CURRENT_BINARY_DIR}/include)
 include_directories (${CMAKE_CURRENT_BINARY_DIR}/private_include)
 
 # Add the lib sources.
-file (GLOB C_FILES src/*.c)
-
-if (BUILD_SHARED_LIBS)
-
-   add_library (jansson SHARED ${C_FILES} src/jansson.def)
-
-   set_target_properties (jansson PROPERTIES
+file(GLOB JANSSON_SRC src/*.c)
+
+set(JANSSON_HDR_PRIVATE
+   ${CMAKE_CURRENT_SOURCE_DIR}/src/hashtable.h
+   ${CMAKE_CURRENT_SOURCE_DIR}/src/jansson_private.h
+   ${CMAKE_CURRENT_SOURCE_DIR}/src/strbuffer.h
+   ${CMAKE_CURRENT_SOURCE_DIR}/src/utf.h
+   ${CMAKE_CURRENT_BINARY_DIR}/private_include/jansson_private_config.h)
+
+set(JANSSON_HDR_PUBLIC 
+   ${CMAKE_CURRENT_BINARY_DIR}/include/jansson_config.h
+   ${CMAKE_CURRENT_SOURCE_DIR}/src/jansson.h)
+
+source_group("Library Sources" FILES ${JANSSON_SRC})
+source_group("Library Private Headers" FILES ${JANSSON_HDR_PRIVATE})
+source_group("Library Public Headers" FILES ${JANSSON_HDR_PUBLIC})
+
+if(JANSSON_BUILD_SHARED_LIBS)
+   add_library(jansson SHARED 
+      ${JANSSON_SRC} 
+      ${JANSSON_HDR_PRIVATE} 
+      ${JANSSON_HDR_PUBLIC} 
+      src/jansson.def)
+
+   set_target_properties(jansson PROPERTIES
       VERSION ${JANSSON_VERSION}
       SOVERSION ${JANSSON_SOVERSION})
-
-else ()
-
-   add_library (jansson ${C_FILES})
-
-endif ()
-
-# LIBRARY for linux
-# RUNTIME for windows (when building shared)
-install (TARGETS jansson
-   ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
-   LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
-   RUNTIME DESTINATION bin
-)
-
-install (FILES
-         ${CMAKE_CURRENT_BINARY_DIR}/include/jansson_config.h
-         ${CMAKE_CURRENT_SOURCE_DIR}/src/jansson.h
-         DESTINATION include)
-
-install (FILES 
-         ${CMAKE_CURRENT_BINARY_DIR}/jansson.pc
-         DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)
-
-# For building Documentation (uses Sphinx)
-OPTION (BUILD_DOCS "Build documentation (uses python-sphinx)." ON)
-if (BUILD_DOCS)
-   find_package(Sphinx)
-
-   if (NOT SPHINX_FOUND)
-      message(WARNING "Sphinx not found. Cannot generate documentation! 
-      Set -DBUILD_DOCS=0 to get rid of this message.")
-   else()
-      if (Sphinx_VERSION_STRING VERSION_LESS 1.0)
-         message(WARNING "Your Sphinx version is too old! 
-               This project requires Sphinx v1.0 or above to produce 
-               proper documentation (you have v${Sphinx_VERSION_STRING}).
-               You will get output but it will have errors.")
-      endif()
-
-      # configured documentation tools and intermediate build results
-      set(BINARY_BUILD_DIR "${CMAKE_CURRENT_BINARY_DIR}/_build")
-
-      # Sphinx cache with pickled ReST documents
-      set(SPHINX_CACHE_DIR "${CMAKE_CURRENT_BINARY_DIR}/_doctrees")
-
-      # CMake could be used to build the conf.py file too,
-      # eg it could automatically write the version of the program or change the theme.
+else()
+   add_library(jansson 
+      ${JANSSON_SRC}
+      ${JANSSON_HDR_PRIVATE} 
+      ${JANSSON_HDR_PUBLIC})

=== debian/changelog ===
jansson (2.7-3ubuntu0.1) xenial-security; urgency=medium

  * SECURITY UPDATE: Stack exhaustion parsing a JSON file
    - debian/patches/CVE-2016-4425.patch: Fix in src/load.c and
      src/jansson_config.h.in
    - CVE-2016-4425

 -- Eduardo Barretto <eduardo.barretto@canonical.com>  Wed, 01 Aug 2018 09:32:47 -0300

jansson (2.7-3) unstable; urgency=medium

  * Always build the documentation (Closes: #789675)

 -- Alessandro Ghedini <ghedo@debian.org>  Tue, 23 Jun 2015 13:11:09 +0200

jansson (2.7-2) unstable; urgency=medium

  * Use dh_sphinxdoc before installing documentation (Closes: #769327)
  * Bump Standards-Version to 3.9.6 (no changes needed)

 -- Alessandro Ghedini <ghedo@debian.org>  Mon, 22 Jun 2015 14:42:51 +0200

jansson (2.7-1) unstable; urgency=medium

  * New upstream release
    - Support ``\u0000`` escapes in the decoder (Closes: #739207)
  * Update symbols file
  * Update upstream copyright

 -- Alessandro Ghedini <ghedo@debian.org>  Thu, 02 Oct 2014 16:05:46 +0200

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,10 @@
 Source: jansson
+Section: libs
 Priority: optional
-Maintainer: Alessandro Ghedini <ghedo@debian.org>
-Build-Depends: debhelper (>= 9), dh-autoreconf
-Build-Depends-Indep: python-sphinx (>= 1.0)
-Standards-Version: 3.9.5
-Section: libs
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Alessandro Ghedini <ghedo@debian.org>
+Build-Depends: debhelper (>= 9), dh-autoreconf, python-sphinx (>= 1.0)
+Standards-Version: 3.9.6
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/jansson.git
 Vcs-Git: git://anonscm.debian.org/collab-maint/jansson.git
 Homepage: http://www.digip.org/jansson/
@@ -44,11 +44,7 @@
 Package: libjansson-doc
 Section: doc
 Architecture: all
-Depends: ${misc:Depends},
- libjs-backbone,
- libjs-jquery,
- libjs-underscore,
- libjs-sphinxdoc (>= 1.0)
+Depends: ${misc:Depends}, ${sphinxdoc:Depends}
 Description: C library for encoding, decoding and manipulating JSON data (doc)
  Jansson is a C library for encoding, decoding and manipulating JSON data.
  .

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --with=autoreconf,sphinxdoc

override_dh_auto_build:
	dh_auto_build
	$(MAKE) html

override_dh_strip:
	dh_strip --dbg-package=libjansson-dbg

## jansson 2.9

=== debian/changelog ===
jansson (2.9-1) unstable; urgency=medium

  * New upstream release
  * Drop 01_CVE-2016-4425.patch (merged upstream)
  * Update symbols file

 -- Alessandro Ghedini <ghedo@debian.org>  Sat, 19 Nov 2016 16:31:48 +0000

jansson (2.7-5) unstable; urgency=high

  * Bump Standards-Version to 3.9.8 (no changes needed)
  * Fix stack exhaustion when parsing JSON as per CVE-2016-4425
    (Closes: #823238)

 -- Alessandro Ghedini <ghedo@debian.org>  Sat, 14 May 2016 16:45:26 +0100

jansson (2.7-4) unstable; urgency=medium

  * Make build reproducible (Closes: #789748)
    Thanks to Juan Picca for the patch
  * Drop -dbg package
  * Update Vcs links
  * Improve cross Build-Depends satisfiability (Closes: #807848)
    Thanks to Helmut Grohne for the patch

 -- Alessandro Ghedini <ghedo@debian.org>  Sat, 23 Apr 2016 13:53:34 +0100

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,12 @@
 Source: jansson
 Section: libs
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Alessandro Ghedini <ghedo@debian.org>
-Build-Depends: debhelper (>= 9), dh-autoreconf, python-sphinx (>= 1.0)
-Standards-Version: 3.9.6
-Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/jansson.git
-Vcs-Git: git://anonscm.debian.org/collab-maint/jansson.git
+Maintainer: Alessandro Ghedini <ghedo@debian.org>
+Build-Depends: debhelper (>= 9), dh-autoreconf
+Build-Depends-Indep: python-sphinx (>= 1.0)
+Standards-Version: 3.9.8
+Vcs-Git: https://anonscm.debian.org/git/collab-maint/jansson.git
+Vcs-Browser: https://anonscm.debian.org/gitweb/?p=collab-maint/jansson.git
 Homepage: http://www.digip.org/jansson/
 
 Package: libjansson4
@@ -56,21 +56,3 @@
   * Extensive test suite
  .
  This package contains the documentation for jansson.
-
-Package: libjansson-dbg
-Priority: extra
-Section: debug
-Architecture: any
-Depends: ${misc:Depends}, libjansson4 (= ${binary:Version})
-Multi-Arch: same
-Description: C library for encoding, decoding and manipulating JSON data (debug)
- Jansson is a C library for encoding, decoding and manipulating JSON data.
- .
- It features:
-  * Simple and intuitive API and data model
-  * Comprehensive documentation
-  * No dependencies on other libraries
-  * Full Unicode support (UTF-8)
-  * Extensive test suite
- .
- This package provides the debugging symbols for jansson.

=== debian/rules ===
#!/usr/bin/make -f

LAST_CHANGE = $(shell dpkg-parsechangelog -S Date)
BUILD_DATE  = $(shell LC_ALL=C date -u "+%B %d, %Y" -d "$(LAST_CHANGE)")
SPHINXOPTS := -D today=\"$(BUILD_DATE)\"

%:
	dh $@ --with=autoreconf

binary binary-indep build build-indep install install-indep:
	dh $@ --with=autoreconf,sphinxdoc

override_dh_auto_build-indep:
	$(MAKE) html SPHINXOPTS="$(SPHINXOPTS)"

override_dh_auto_test-indep override_dh_auto_install-indep:

## jansson 2.10

=== CMakeLists.txt ===
--- 
+++ 
@@ -61,27 +61,35 @@
 	option(JANSSON_STATIC_CRT "Link the static CRT libraries" OFF )
 endif ()
 
+option(JANSSON_EXAMPLES "Compile example applications" ON)
+
+if (UNIX)
+   option(JANSSON_COVERAGE "(GCC Only! Requires gcov/lcov to be installed). Include target for doing coverage analysis for the test suite. Note that -DCMAKE_BUILD_TYPE=Debug must be set" OFF)
+   option(JANSSON_COVERALLS "Generate coverage info for Coveralls" OFF)
+   option(JANSSON_COVERALLS_UPLOAD "Upload coverage info to Coveralls (Only works via Travis)" ON)
+endif ()
+
 # Set some nicer output dirs.
 set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/bin)
 set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/lib)
 set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/lib)
+set(JANSSON_TEMP_DIR ${PROJECT_BINARY_DIR}/tmp)
 
 # Give the debug version a different postfix for windows,
 # so both the debug and release version can be built in the
 # same build-tree on Windows (MSVC).
 if (WIN32)
    set(CMAKE_DEBUG_POSTFIX "_d")
-else (WIN32)
 endif (WIN32)
 
 # This is how I thought it should go
 # set (JANSSON_VERSION "2.3.1")
 # set (JANSSON_SOVERSION 2)
 
-set(JANSSON_DISPLAY_VERSION "2.7")
+set(JANSSON_DISPLAY_VERSION "2.10")
 
 # This is what is required to match the same numbers as automake's
-set(JANSSON_VERSION "4.7.0")
+set(JANSSON_VERSION "4.10.0")
 set(JANSSON_SOVERSION 4)
 
 # for CheckFunctionKeywords
@@ -97,15 +105,30 @@
    # Turn off Microsofts "security" warnings.
    add_definitions( "/W3 /D_CRT_SECURE_NO_WARNINGS /wd4005 /wd4996 /nologo" )
    
-   if (STATIC_CRT)
-      set(CMAKE_C_FLAGS_RELEASE "/MT")
-      set(CMAKE_C_FLAGS_DEBUG "/MTd")
+   if (JANSSON_STATIC_CRT)
+      set(CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE} /MT")
+      set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} /MTd")
    endif()
    
 endif()
 
 if (NOT WIN32 AND (CMAKE_COMPILER_IS_GNUCC OR CMAKE_COMPILER_IS_GNUCXX))
    add_definitions("-fPIC")
+endif()
+
+message("C compiler: ${CMAKE_C_COMPILER_ID}")
+
+# Coverage only works with GCC for a debug build.
+if (JANSSON_COVERALLS)
+   set(JANSSON_COVERAGE ON)
+endif()
+
+if (JANSSON_COVERAGE)
+   include(CodeCoverage)
+   include(Coveralls)
+
+   # This adds coverage arguments to gcc/clang.
+   coveralls_turn_on_coverage()
 endif()
 
 check_include_files (endian.h HAVE_ENDIAN_H)
@@ -227,7 +250,7 @@
 # detect what to use for the 64 bit type.
 # Note: I will prefer long long if I can get it, as that is what the automake system aimed for.
 if (NOT DEFINED JSON_INT_T)
-   if (HAVE_LONG_LONG_INT AND (${LONG_LONG_INT} EQUAL 8))
+   if (HAVE_LONG_LONG_INT AND ((${LONG_LONG_INT}) EQUAL 8))
       set (JSON_INT_T "long long")
    elseif (HAVE_INT64_T)
       set (JSON_INT_T int64_t)
@@ -280,31 +303,10 @@
    set (JSON_INLINE)
 endif()
 
-# Find our snprintf
-check_function_exists (snprintf HAVE_SNPRINTF)
-check_function_exists (_snprintf HAVE__SNPRINTF)
-
-if (HAVE_SNPRINTF)
-   set(JSON_SNPRINTF snprintf)
-elseif (HAVE__SNPRINTF)
-   set(JSON_SNPRINTF _snprintf)
-endif () 
-
 check_c_source_compiles ("int main() { unsigned long val; __sync_bool_compare_and_swap(&val, 0, 1); return 0; } " HAVE_SYNC_BUILTINS)
 check_c_source_compiles ("int main() { char l; unsigned long v; __atomic_test_and_set(&l, __ATOMIC_RELAXED); __atomic_store_n(&v, 1, __ATOMIC_RELEASE); __atomic_load_n(&v, __ATOMIC_ACQUIRE); return 0; }" HAVE_ATOMIC_BUILTINS)
 
-# Create pkg-conf file.
-# (We use the same files as ./configure does, so we
-#  have to defined the same variables used there).
-if(NOT DEFINED CMAKE_INSTALL_LIBDIR)
-  set(CMAKE_INSTALL_LIBDIR lib)
-endif(NOT DEFINED CMAKE_INSTALL_LIBDIR)
-set(prefix      ${CMAKE_INSTALL_PREFIX})
-set(exec_prefix ${CMAKE_INSTALL_PREFIX})
-set(libdir      ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR})
-set(VERSION     ${JANSSON_DISPLAY_VERSION})
-configure_file(${CMAKE_CURRENT_SOURCE_DIR}/jansson.pc.in
-               ${CMAKE_CURRENT_BINARY_DIR}/jansson.pc @ONLY)
+set (JANSSON_INITIAL_HASHTABLE_ORDER 3 CACHE STRING "Number of buckets new object hashtables contain is 2 raised to this power. The default is 3, so empty hashtables contain 2^3 = 8 buckets.")
 
 # configure the public config file
 configure_file (${CMAKE_CURRENT_SOURCE_DIR}/cmake/jansson_config.h.cmake
@@ -348,14 +350,3 @@
    add_library(jansson SHARED 
       ${JANSSON_SRC} 
       ${JANSSON_HDR_PRIVATE} 
-      ${JANSSON_HDR_PUBLIC} 
-      src/jansson.def)
-
-   set_target_properties(jansson PROPERTIES
-      VERSION ${JANSSON_VERSION}
-      SOVERSION ${JANSSON_SOVERSION})
-else()
-   add_library(jansson 
-      ${JANSSON_SRC}
-      ${JANSSON_HDR_PRIVATE} 
-      ${JANSSON_HDR_PUBLIC})

=== debian/changelog ===
jansson (2.10-1) unstable; urgency=medium

  * New upstream release
  * Update Standards-Version to 4.0.0 (no changes needed)
  * Update symbols file

 -- Alessandro Ghedini <ghedo@debian.org>  Mon, 24 Jul 2017 00:17:43 +0100

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Alessandro Ghedini <ghedo@debian.org>
 Build-Depends: debhelper (>= 9), dh-autoreconf
 Build-Depends-Indep: python-sphinx (>= 1.0)
-Standards-Version: 3.9.8
+Standards-Version: 4.0.0
 Vcs-Git: https://anonscm.debian.org/git/collab-maint/jansson.git
 Vcs-Browser: https://anonscm.debian.org/gitweb/?p=collab-maint/jansson.git
 Homepage: http://www.digip.org/jansson/

## jansson 2.11

=== debian/changelog ===
jansson (2.11-1) unstable; urgency=medium

  * New upstream release
  * Fix useless-autoreconf-build-depends dh-autoreconf
  * Switch to Python3 version of Sphinx
  * Update symbols file
  * Use SOURCE_DATE_EPOCH instead of dpkg-parsechangelog output
  * Update doc-base paths

 -- Alessandro Ghedini <ghedo@debian.org>  Sun, 11 Feb 2018 19:19:55 +0000

=== debian/control ===
--- 
+++ 
@@ -2,11 +2,11 @@
 Section: libs
 Priority: optional
 Maintainer: Alessandro Ghedini <ghedo@debian.org>
-Build-Depends: debhelper (>= 9), dh-autoreconf
-Build-Depends-Indep: python-sphinx (>= 1.0)
-Standards-Version: 4.0.0
-Vcs-Git: https://anonscm.debian.org/git/collab-maint/jansson.git
-Vcs-Browser: https://anonscm.debian.org/gitweb/?p=collab-maint/jansson.git
+Build-Depends: debhelper (>= 11)
+Build-Depends-Indep: python3-sphinx (>= 1.0)
+Standards-Version: 4.1.3
+Vcs-Git: https://salsa.debian.org/debian/jansson.git
+Vcs-Browser: https://salsa.debian.org/debian/jansson
 Homepage: http://www.digip.org/jansson/
 
 Package: libjansson4
